scriptname GuardPlacementThreadManager extends Quest
 
Quest property GuardPlacementQuest auto
{The name of the thread management quest.}
 
Activator property GuardPlacementFutureActivator auto
{Our Future object.}
 
ObjectReference property GuardPlacementFutureAnchor auto
{Our Future Anchor object reference.}
 
Static property XMarker auto
{Tedious to define properties in the threads and hook up in CK over and over, so define things we need here. MoveGuardMarkerNearPlayer() needs XMarkers.}

Spell property SummonArmySpellSingleThread auto
Spell property SummonArmySpellMultiThread10 auto
Spell property SummonArmySpellMultiThread20 auto

int property thread_limit = 10 auto hidden

GuardPlacementThread01 thread01
GuardPlacementThread02 thread02
GuardPlacementThread03 thread03
GuardPlacementThread04 thread04
GuardPlacementThread05 thread05
GuardPlacementThread06 thread06
GuardPlacementThread07 thread07
GuardPlacementThread08 thread08
GuardPlacementThread09 thread09
GuardPlacementThread10 thread10
GuardPlacementThread11 thread11
GuardPlacementThread12 thread12
GuardPlacementThread13 thread13
GuardPlacementThread14 thread14
GuardPlacementThread15 thread15
GuardPlacementThread16 thread16
GuardPlacementThread17 thread17
GuardPlacementThread18 thread18
GuardPlacementThread19 thread19
GuardPlacementThread20 thread20
 
Event OnInit()
    ;Register for the event that will start all threads
    ;NOTE - This needs to be re-registered once per load! Use an alias and OnPlayerLoadGame() in a real implementation.
    RegisterForModEvent("MyMod_OnGuardPlacement", "OnGuardPlacement")

    ;Let's cast our threads to local variables so things are less cluttered in our code
    thread01 = GuardPlacementQuest as GuardPlacementThread01
    thread02 = GuardPlacementQuest as GuardPlacementThread02
    thread03 = GuardPlacementQuest as GuardPlacementThread03
    thread04 = GuardPlacementQuest as GuardPlacementThread04
    thread05 = GuardPlacementQuest as GuardPlacementThread05
    thread06 = GuardPlacementQuest as GuardPlacementThread06
    thread07 = GuardPlacementQuest as GuardPlacementThread07
    thread08 = GuardPlacementQuest as GuardPlacementThread08
    thread09 = GuardPlacementQuest as GuardPlacementThread09
    thread10 = GuardPlacementQuest as GuardPlacementThread10
    thread11 = GuardPlacementQuest as GuardPlacementThread11
    thread12 = GuardPlacementQuest as GuardPlacementThread12
    thread13 = GuardPlacementQuest as GuardPlacementThread13
    thread14 = GuardPlacementQuest as GuardPlacementThread14
    thread15 = GuardPlacementQuest as GuardPlacementThread15
    thread16 = GuardPlacementQuest as GuardPlacementThread16
    thread17 = GuardPlacementQuest as GuardPlacementThread17
    thread18 = GuardPlacementQuest as GuardPlacementThread18
    thread19 = GuardPlacementQuest as GuardPlacementThread19
    thread20 = GuardPlacementQuest as GuardPlacementThread20

    ;Give tutorial spells to the player!
    Game.GetPlayer().AddSpell(SummonArmySpellSingleThread)
    Game.GetPlayer().AddSpell(SummonArmySpellMultiThread10)
    Game.GetPlayer().AddSpell(SummonArmySpellMultiThread20)
EndEvent
 
;The 'public-facing' function that our MagicEffect script will interact with.
ObjectReference function PlaceConjuredGuardAsync(ActorBase akGuard)
    int i = 0
	ObjectReference future
	while !future
		if !thread01.busy() && thread_limit >= 1
            future = thread01.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
		elseif !thread02.busy() && thread_limit >= 2
			future = thread02.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread03.busy() && thread_limit >= 3
            future = thread03.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread04.busy() && thread_limit >= 4
            future = thread04.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread05.busy() && thread_limit >= 5
            future = thread05.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread06.busy() && thread_limit >= 6
            future = thread06.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread07.busy() && thread_limit >= 7
            future = thread07.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread08.busy() && thread_limit >= 8
            future = thread08.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
		elseif !thread09.busy() && thread_limit >= 9
            future = thread09.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
		elseif !thread10.busy() && thread_limit >= 10
            future = thread10.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread11.busy() && thread_limit >= 11
            future = thread11.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread12.busy() && thread_limit >= 12
            future = thread12.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread13.busy() && thread_limit >= 13
            future = thread13.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread14.busy() && thread_limit >= 14
            future = thread14.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread15.busy() && thread_limit >= 15
            future = thread15.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread16.busy() && thread_limit >= 16
            future = thread16.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread17.busy() && thread_limit >= 17
            future = thread17.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread18.busy() && thread_limit >= 18
            future = thread18.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread19.busy() && thread_limit >= 19
            future = thread19.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
        elseif !thread20.busy() && thread_limit >= 20
            future = thread20.get_async(GuardPlacementFutureActivator, GuardPlacementFutureAnchor, akGuard, XMarker)
		else
			;All threads are busy; start all threads, wait, and try again.
            wait_all()
		endif
	endWhile
 
	return future
endFunction
 
function wait_all()
    RaiseEvent_OnGuardPlacement()
    begin_waiting()
endFunction

function begin_waiting()
    bool waiting = true
    int i = 0
    while waiting
        if thread01.busy() || thread02.busy() || thread03.busy() || thread04.busy() || thread05.busy() || \
           thread06.busy() || thread07.busy() || thread08.busy() || thread09.busy() || thread10.busy() || \ 
           thread11.busy() || thread12.busy() || thread13.busy() || thread14.busy() || thread15.busy() || \ 
           thread16.busy() || thread17.busy() || thread18.busy() || thread19.busy() || thread20.busy()
            i += 1
            Utility.wait(0.1)
            if i >= 100
                debug.trace("Error: A catastrophic error has occurred. All threads have become unresponsive. Please debug this issue or notify the author.")
                i = 0
                ;Fail by returning None. The mod needs to be fixed.
                return
            endif
        else
            waiting = false
        endif
    endWhile
endFunction

;A helper function that can avert permanent thread failure if something goes wrong
function TryToUnlockThread(ObjectReference akFuture)
    bool success = false
    if thread01.has_future(akFuture)
        success = thread01.force_unlock()
    elseif thread02.has_future(akFuture)
        success = thread02.force_unlock()
    elseif thread03.has_future(akFuture)
        success = thread03.force_unlock()
    elseif thread04.has_future(akFuture)
        success = thread04.force_unlock()
    elseif thread05.has_future(akFuture)
        success = thread05.force_unlock()
    elseif thread06.has_future(akFuture)
        success = thread06.force_unlock()
    elseif thread07.has_future(akFuture)
        success = thread07.force_unlock()
    elseif thread08.has_future(akFuture)
        success = thread08.force_unlock()
    elseif thread09.has_future(akFuture)
        success = thread09.force_unlock()
    elseif thread10.has_future(akFuture)
        success = thread10.force_unlock()
    elseif thread11.has_future(akFuture)
        success = thread11.force_unlock()
    elseif thread12.has_future(akFuture)
        success = thread12.force_unlock()
    elseif thread13.has_future(akFuture)
        success = thread13.force_unlock()
    elseif thread14.has_future(akFuture)
        success = thread14.force_unlock()
    elseif thread15.has_future(akFuture)
        success = thread15.force_unlock()
    elseif thread16.has_future(akFuture)
        success = thread16.force_unlock()
    elseif thread17.has_future(akFuture)
        success = thread17.force_unlock()
    elseif thread18.has_future(akFuture)
        success = thread18.force_unlock()
    elseif thread19.has_future(akFuture)
        success = thread19.force_unlock()
    elseif thread20.has_future(akFuture)
        success = thread20.force_unlock()
    endif
 
    if !success
        debug.trace("Error: A thread has encountered an error and has become unresponsive.")
    else
        debug.trace("Warning: An unresponsive thread was successfully unlocked.")
    endif
endFunction

;Create the ModEvent that will start this thread
function RaiseEvent_OnGuardPlacement()
    int handle = ModEvent.Create("MyMod_OnGuardPlacement")
    if handle
        ModEvent.Send(handle)
    else
        ;pass
    endif
endFunction